import io from "socket.io-client";
import { useState, useEffect } from "react";

let socket;

export default function Document() {
  const [username, setUsername] = useState("");
  const [chosenUsername, setChosenUsername] = useState("");
  const [text, setText] = useState("");
  const [token, setToken] = useState("");

  useEffect(() => {
    socketInitializer();
  }, [chosenUsername]);

  useEffect(() => {
    const data = new URLSearchParams();
    data.append("username", "user")
    data.append("password", "passtest")

    const fetchData = async (data) => {
        const res = await fetch("http://localhost:8000/api/token", { method: 'POST', body: data})
        const json = await res.json();
        setToken(() => json["access_token"])
      }

      fetchData(data)
  }, [])

  useEffect(() => {
    if (token) {
        const fetchData = async () => {
            const res = await fetch("http://localhost:8000/api/documents/63866c991b4175934db26981", {
                method: "GET",
                headers: {
                    'Authorization': `Bearer ${token}`
                }
            })
            const json = await res.json();
            setText(() => json["data"])
        }

        fetchData()
    }
  }, [token])

  useEffect(() => {
    const interval = setInterval(() => {
      fetch("http://localhost:8000/api/documents/63866c991b4175934db26981", {
        method: 'PUT',
        body: `{"data": "${text}"}`,
        headers: {
            'Content-type': 'application/json',
            'Authorization': `Bearer ${token}`
        }
    })
    }, 500);

    return () => clearInterval(interval);
  }, [token, text])

  const socketInitializer = async () => {
    await fetch("/api/socket");

    socket = io();

    socket.emit('create', chosenUsername);
    console.log(chosenUsername)

    socket.on("newIncomingText", (text) => {
        setText(() => text);
        console.log('text' + text);
      });
  };

  const sendText = async () => {
    socket.emit("createdText", text, chosenUsername);
    setText(() => text);
  };

  const handleKey = () => {
    if (text) {
      sendText();
    }
  };

  return (
    <div className="flex items-center p-4 mx-auto min-h-screen justify-center bg-purple-500">
      <main className="gap-4 flex flex-col items-center justify-center w-full h-full">
        {!chosenUsername ? (
          <>
            <h3 className="font-bold text-white text-xl">
              doc_id?
            </h3>
            <input
              type="text"
              placeholder="Identity..."
              value={username}
              className="p-3 rounded-md outline-none"
              onChange={(e) => setUsername(e.target.value)}
            />
            <button
              onClick={() => {
                setChosenUsername(username);
              }}
              className="bg-white rounded-md px-4 py-2 text-xl"
            >
              Go!
            </button>
          </>
        ) : (
          <>
            <p className="font-bold text-white text-xl">
              Your username: {username}
            </p>

            <textarea
                placeholder="Type..."
                onKeyUp={handleKey}
                value={text}
                onChange={(e) => setText(e.target.value)}
            />
          </>
        )}
      </main>
    </div>
  );
}